package weka.core;

import java.util.*;

public interface DataRealizator
{
    public void randomize(Random random) throws Exception;    
    public void randomize(Random random, int numRndFolds, int numRndInst) throws Exception;
    public void stratify(int numFolds) throws Exception;
    public Instances testCV(int numFolds, int numFold) throws Exception; 
    public Instances testCVNoCopy(int numFolds, int numFold) throws Exception;
    public Instances testCVRatio(int numFolds, int numFold, double ratio) throws Exception;
    public Instances trainCV(int numFolds, int numFold) throws Exception;
    public Instances trainCVNoCopy(int numFolds, int numFold) throws Exception;
    public Instances trainCVRatio(int numFolds, int numFold, double ratio) throws Exception;
    public int defaultNumFolds();
    public int numAttributes();
    public int numInstances();
    public Instances emptySet();
}