package weka.core;

import java.util.*;
import java.io.*;
import weka.core.*;

public class InstancesAscSetUnite
{
    private void unite(String dir, String outFileName) throws Exception
    {
        int i;
        Enumeration instEnum;
        InstancesAscSet set = new InstancesAscSet(dir);
        int numFolds = set.defaultNumFolds();
        Instances currFoldTrain, currFoldTest;
        Instances res = null;
        Instance ins;
        
        System.out.println("\n\nSTART");
        for (i=0; i<numFolds; i++) {
            System.out.print("\n!!!!! " + i + " !!!!!!!");
            currFoldTrain = set.trainCVNoCopy(numFolds, i);
            currFoldTest = set.testCVNoCopy(numFolds, i);            
            if (res==null) {
                System.out.println("INIT RES");
                res = new Instances(currFoldTrain, 0);
            }
            System.out.print("train");            
            instEnum = currFoldTrain.enumerateInstances();
            while (instEnum.hasMoreElements()) {
                ins = (Instance)instEnum.nextElement();
                if (!this.isMember(ins, res)) {
                    res.addNoCopy(ins);
                }
                System.out.print(".");
            }
            System.out.print("\ntest");            
            instEnum = currFoldTest.enumerateInstances();
            while (instEnum.hasMoreElements()) {
                ins = (Instance)instEnum.nextElement();
                if (!this.isMember(ins, res)) {
                    res.addNoCopy(ins);
                }
                System.out.print(".");
            }
            System.out.println("\n$$$$$ CURR SIZE = " + res.size() + " $$$$");
        } // all folds
        System.out.print("\nwriting to file");
        FileOutputStream outFile = new FileOutputStream(outFileName);
        outFile.write(res.toString().getBytes());
        outFile.close();
        System.out.println("END");
    }
    
    private boolean isMember(Instance ins, Instances data)
    {
        Enumeration instEnum = data.enumerateInstances();
        Instance currIns;
        while (instEnum.hasMoreElements()) {
            currIns = (Instance)instEnum.nextElement();
            if (this.isInstanceEqual(ins, currIns)) {
                return true;
            }
        }
        return false;
    }
    
    private boolean isInstanceEqual(Instance ins1, Instance ins2)
    {
        int i;
        double val1, val2;
        int numAtt = ins1.numAttributes();
        if (numAtt != ins2.numAttributes()) return false;
        for (i=0; i<numAtt; i++) {
            val1 = ins1.value(i);
            val2 = ins2.value(i);
            if (!Utils.eq(val1, val2)) {
                return false;
            }
        }
        return true;
    }
    
    public static void main(String[] args) {
        try {
            InstancesAscSetUnite uniter = new InstancesAscSetUnite();
            uniter.unite(args[0], args[1]);
        } catch (Exception e) {            
            System.err.println(e.getMessage());            
            e.printStackTrace();
        }  
    }            
}